#
# {{ ansible_managed }}
#

#file proxysql.cfg

########################################################################################
# This config file is parsed using libconfig , and its grammar is described in:        
# http://www.hyperrealm.com/libconfig/libconfig_manual.html#Configuration-File-Grammar 
# Grammar is also copied at the end of this file                                       
########################################################################################

########################################################################################
# IMPORTANT INFORMATION REGARDING THIS CONFIGURATION FILE:                             
########################################################################################
# On startup, ProxySQL reads its config file (if present) to determine its datadir. 
# What happens next depends on if the database file (disk) is present in the defined
# datadir (i.e. "/var/lib/proxysql/proxysql.db").
#
# If the database file is found, ProxySQL initializes its in-memory configuration from 
# the persisted on-disk database. So, disk configuration gets loaded into memory and 
# then propagated towards the runtime configuration. 
#
# If the database file is not found and a config file exists, the config file is parsed 
# and its content is loaded into the in-memory database, to then be both saved on-disk 
# database and loaded at runtime.
#
# IMPORTANT: If a database file is found, the config file is NOT parsed. In this case
#            ProxySQL initializes its in-memory configuration from the persisted on-disk
#            database ONLY. In other words, the configuration found in the proxysql.cnf
#            file is only used to initial the on-disk database read on the first startup.
#
# In order to FORCE a re-initialise of the on-disk database from the configuration file 
# the ProxySQL service should be started with "service proxysql initial".
#
########################################################################################

datadir="{{ proxysql_datadir }}"
errorlog="{{ proxysql_datadir }}/proxysql.log"

admin_variables=
{
    admin_credentials="{{ proxysql_admin_username }}:{{ proxysql_admin_password }}"
    mysql_ifaces="{{ proxysql_admin_bind_address }}:{{ proxysql_admin_bind_port }}"
}

mysql_variables=
{
    threads={{ proxysql_mysql_threads }}
    max_connections={{ proxysql_mysql_max_connections }}
    default_charset="{{ proxysql_mysql_default_charset }}"
    default_collation_connection="{{ proxysql_mysql_default_collation_connection }}"
    default_query_delay={{ proxysql_mysql_default_query_delay }}
    default_query_timeout={{ proxysql_mysql_default_query_timeout }}
    poll_timeout={{ proxysql_mysql_poll_timeout }}
    interfaces="{{ proxysql_mysql_interfaces }}" #	interfaces="0.0.0.0:6033;/tmp/proxysql.sock"
    default_schema="{{ proxysql_mysql_default_schema }}"
    server_version="{{ proxysql_mysql_server_version }}"
    connect_timeout_server={{ proxysql_mysql_connect_timeout_server }}
    monitor_username="{{ proxysql_mysql_monitor_username }}"
    monitor_password="{{ proxysql_mysql_monitor_password }}"
    monitor_history={{ proxysql_mysql_monitor_history }}
    monitor_connect_interval={{ proxysql_mysql_monitor_connect_interval }}
    monitor_ping_interval={{ proxysql_mysql_monitor_ping_interval }}
    monitor_read_only_interval={{ proxysql_mysql_monitor_read_only_interval }}
    monitor_read_only_timeout={{ proxysql_mysql_monitor_read_only_timeout }}
    monitor_galera_healthcheck_timeout={{ proxysql_mysql_monitor_galera_healthcheck_timeout }}
    monitor_galera_healthcheck_max_timeout_count={{ proxysql_mysql_monitor_galera_healthcheck_max_timeout_count}}
    monitor_galera_healthcheck_interval={{ proxysql_mysql_monitor_galera_healthcheck_interval}}
    ping_interval_server_msec={{ proxysql_mysql_ping_interval_server_msec }}
    ping_timeout_server={{ proxysql_mysql_ping_timeout_server }}
    commands_stats={{ proxysql_mysql_commands_stats }}
    sessions_sort={{ proxysql_mysql_sessions_sort }}
    connect_retries_on_failure={{ proxysql_mysql_connect_retries_on_failure }}
    hostgroup_manager_verbose={{ proxysql_mysql_hostgroup_manager_verbose }}
    set_query_lock_on_hostgroup={{ proxysql_mysql_set_query_lock_on_hostgroup }}
    wait_timeout={{ proxysql_mysql_wait_timeout }}
    max_allowed_packet={{ proxysql_mysql_max_allowed_packet | default('512M') | replace('G', '000M') | replace('M', '000K') | replace('K', '000') }}
    monitor_slave_lag_when_null={{ proxysql_mysql_monitor_slave_lag_when_null }}
    query_digests_max_query_length={{ proxysql_mysql_query_digests_max_query_length }}
    query_digests_max_digest_length={{ proxysql_mysql_query_digests_max_digest_length }}
    {% if proxysql_ssl %}
    have_ssl={{ proxysql_ssl | default('0') }}
    ssl_p2s_ca="{{ proxysql_datadir }}/p2s-ca.cert"
    ssl_p2s_cert="{{ proxysql_datadir }}/p2s-client.crt"
    ssl_p2s_key="{{ proxysql_datadir }}/p2s-client.key"
    {% endif %}
}

# defines all the MySQL servers
mysql_servers =
(
    {% for mysql_server in proxysql_mysql_servers %}
    {
        address = "{{ mysql_server.address }}" # no default, required . If port is 0 , address is interpred as a Unix Socket Domain
        port = {{ mysql_server.port }} # no default, required . If port is 0 , address is interpred as a Unix Socket Domain
        hostgroup = {{ mysql_server.hostgroup }} # no default, required
        status = "{{ mysql_server.status | default('ONLINE') }}" # default ONLINE
        weight = {{ mysql_server.weight | default(1) }} # default 1
        compression = {{ mysql_server.compression | default(0) }}  # default 0
        comment = "{{ mysql_server.comment | default('') }}" # default ""
        {%if mysql_server.max_replication_lag is defined %}  # Only printed when defind as it is only relevant in asynchronous replication systems.
        max_replication_lag = {{ mysql_server.max_replication_lag }} # default 0 - If greater than 0 and replication lag passes such threshold, the server is shunned
        {% endif %}
        max_connections = {{ mysql_server.max_connections | default(proxysql_mysql_max_connections) }} # default global max_connections
    }
    {%- if not loop.last -%}
    ,
    {% endif %}
    {% endfor %}
)

# defines all the MySQL users
mysql_users:
(
    {% for mysql_user in proxysql_mysql_users %}
    {% if mysql_user.username != proxysql_mysql_monitor_username %}
    {
        username = "{{ mysql_user.username }}"
        password = "{{ mysql_user.password }}"
        default_hostgroup = {{ mysql_user.default_hostgroup | default(0) }}  # default 0
        active = {{ mysql_user.active | default(1) }}  # default 1
        {% if mysql_user.max_connections is defined %}
        max_connections = {{ mysql_user.max_connections }}
        {% endif %}
        {% if mysql_user.default_schema is defined %}
        default_schema = "{{ mysql_user.default_schema }}"
        {% endif %}
    }
    {%- if not loop.last -%}
    ,
    {% endif %}
    {% endif %}
    {% endfor %}
)

#defines MySQL Query Rules
mysql_query_rules:
(
    {% for mysql_query_rule in proxysql_mysql_query_rules %}
    {
        rule_id = {{ mysql_query_rule.rule_id }}  # MUST be UNIQUE
        active = {{ mysql_query_rule.active | default(1) }}  # default 1
        {% if mysql_query_rule.username is defined %}
        username = "{{ mysql_query_rule.username }}"
        {% endif %}
        {% if mysql_query_rule.schemaname is defined %}
        schemaname = "{{ mysql_query_rule.schemaname }}"
        {% endif %}
        flagIN = {{ mysql_query_rule.flagIN | default(0) | int }} # default 0
        {% if mysql_query_rule.flagOUT is defined %}
        flagOUT = {{ mysql_query_rule.flagOUT | int }}
        {% endif %}
        {% if mysql_query_rule.client_addr is defined %}
        client_addr = "{{ mysql_query_rule.client_addr }}"
        {% endif %}
        {% if mysql_query_rule.proxy_addr is defined %}
        proxy_addr = "{{ mysql_query_rule.proxy_addr }}"
        {% endif %}
        {% if mysql_query_rule.proxy_port is defined %}
        proxy_port = {{ mysql_query_rule.proxy_port | int }}
        {% endif %}
        {% if mysql_query_rule.digest is defined %}
        digest = "{{ mysql_query_rule.digest }}"
        {% endif %}
        {% if mysql_query_rule.match_digest is defined %}
        match_digest = "{{ mysql_query_rule.match_digest }}"
        {% endif %}
        {% if mysql_query_rule.match_pattern is defined %}
        match_pattern = "{{ mysql_query_rule.match_pattern }}"
        {% endif %}
        negate_match_pattern = {{ mysql_query_rule.negate_match_pattern | default(0) | int }} # default 0
        {% if mysql_query_rule.replace_pattern is defined %}
        replace_pattern = "{{ mysql_query_rule.replace_pattern }}"
        {% endif %}
        re_modifiers = "{{ mysql_query_rule.re_modifiers | default('CASELESS') }}" # default CASELESS
        {% if mysql_query_rule.destination_hostgroup is defined %}
        destination_hostgroup = {{ mysql_query_rule.destination_hostgroup | int }}
        {% endif %}
        {% if mysql_query_rule.cache_ttl is defined %}
        cache_ttl = {{ mysql_query_rule.cache_ttl | int }}
        {% endif %}
        {% if mysql_query_rule.cache_empty_result is defined %}
        cache_empty_result = {{ mysql_query_rule.cache_empty_result | int }}
        {% endif %}
        {% if mysql_query_rule.cache_timeout is defined %}
        cache_timeout = {{ mysql_query_rule.cache_timeout | int }}
        {% endif %}
        {% if mysql_query_rule.timeout is defined %}
        timeout = {{ mysql_query_rule.timeout | int }}
        {% endif %}
        {% if mysql_query_rule.retries is defined %}
        retries = {{ mysql_query_rule.retries | int }}
        {% endif %}
        {% if mysql_query_rule.delay is defined %}
        delay = {{ mysql_query_rule.delay | int }}
        {% endif %}
        {% if mysql_query_rule.next_query_flagIN is defined %}
        next_query_flagIN = {{ mysql_query_rule.next_query_flagIN | int }}
        {% endif %}
        {% if mysql_query_rule.mirror_flagOUT is defined %}
        mirror_flagOUT = {{ mysql_query_rule.mirror_flagOUT | int }}
        {% endif %}
        {% if mysql_query_rule.mirror_hostgroup is defined %}
        mirror_hostgroup = {{ mysql_query_rule.mirror_hostgroup | int }}
        {% endif %}
        {% if mysql_query_rule.error_msg is defined %}
        error_msg = "{{ mysql_query_rule.error_msg }}"
        {% endif %}
        {% if mysql_query_rule.OK_msg is defined %}
        OK_msg = "{{ mysql_query_rule.OK_msg }}"
        {% endif %}
        {% if mysql_query_rule.sticky_conn is defined %}
        sticky_conn = {{ mysql_query_rule.sticky_conn | int }}
        {% endif %}
        {% if mysql_query_rule.multiplex is defined %}
        multiplex = {{ mysql_query_rule.multiplex | int }}
        {% endif %}
        {% if mysql_query_rule.gtid_from_hostgroup is defined %}
        gtid_from_hostgroup = {{ mysql_query_rule.gtid_from_hostgroup | int }}
        {% endif %}
        {% if mysql_query_rule.log is defined %}
        log = {{ mysql_query_rule.log | int }}
        {% endif %}
        apply = {{ mysql_query_rule.apply | default(1) | int }}
        comment = "{{ mysql_query_rule.comment | default('No comment passed in ansible variables') }}"
    }
    {%- if not loop.last -%}
    ,
    {% endif %}
    {% endfor %}
)

scheduler=
(
    {%- for scheduler in proxysql_scheduler -%}
    {
        id = {{ scheduler.id }}
        active = {{ scheduler.active }}
        interval_ms = {{ scheduler.interval_ms }}
        filename = "{{ scheduler.filename }}"
        {%- for arg in scheduler.args -%}
            arg{{ loop.index }} = "{{ arg }}"
        {% endfor %}
    }
    {%- if not loop.last -%}
    ,
    {% endif %}
    {% endfor %}
)

mysql_replication_hostgroups=
(
    {% for replication_hostgroup in proxysql_mysql_replication_hostgroups %}
    {
        writer_hostgroup = {{ replication_hostgroup.writer_hostgroup }}
        reader_hostgroup = {{ replication_hostgroup.reader_hostgroup }}
        comment = "{{ replication_hostgroup.comment | default('No comment passed in ansible variables') }}"
    }
    {%- if not loop.last -%}
    ,
    {% endif %}
    {% endfor %}
)


mysql_galera_hostgroups=
(
    {% for galera_hostgroup in proxysql_mysql_galera_hostgroups %}
    {
        writer_hostgroup = {{ galera_hostgroup.writer_hostgroup }}
        backup_writer_hostgroup = {{ galera_hostgroup.backup_writer_hostgroup }}
        reader_hostgroup = {{ galera_hostgroup.reader_hostgroup }}
        offline_hostgroup = {{ galera_hostgroup.offline_hostgroup }}
        max_writers = {{ galera_hostgroup.max_writers | default(1) }}
        writer_is_also_reader = {{ galera_hostgroup.writer_is_also_reader | default(1) }} # default 1
        max_transactions_behind = {{ galera_hostgroup.max_transactions_behind | default(0) }}  # default 0 (unlimited)
        comment = "{{ galera_hostgroup.comment | default('No comment passed in ansible variables') }}"
    }
    {%- if not loop.last -%}
    ,
    {% endif %}
    {% endfor %}
)
